'***************************************************************************
' VBIS5032pb.INC For Power Basic
'
' VB/ISAM, VB/ISAM MX & VB/ISAM MU - Copyright (c) Software Source 1991-2008;
' all rights reserved.  VB/ISAM is a proprietary computer software product
' provided by its copyright holder, Software Source (577 Chickasaw Ct. San Jose, CA 95123);
' both the software and its documentation are
' copyrighted, and you may not copy or use either except as expressly
' provided in the VB/ISAM Software License.
'
' This include file for Power Basic is supplied courtesy
' of Michael Meeks 2/8/2001.
'***************************************************************************

'Option Explicit

%VIS_OK = 0
%VIS_NOT_FOUND = 1
%VIS_UPDATE_VIOLATION = 2
%VIS_ACCESS_DENIED = 3
%VIS_BAD_DATASET_NUMBER = 4
%VIS_BAD_FORMAT = 5
%VIS_INVALID_KEY = 6
%VIS_BAD_PARAMETER_VALUE = 7
%VIS_BAD_FILE = 8
%VIS_ALREADY_EXISTS = 9
%VIS_NO_ROOM = 10
%VIS_DISK_FULL = 11
%VIS_OUT_OF_MEMORY = 12
%VIS_DOS_ERROR = 13
%VIS_DISK_ERROR = 14
%VIS_DATA_VALIDITY_CHECK = 15
%VIS_INVALID_SECONDARY_KEY = 16
%VIS_SEQUENCE_ERROR = 17
%VIS_OUT_OF_FILE_HANDLES = 18
%VIS_BUSY = 19
%VIS_INVALID_PASSWORD = 20
%VIS_FUNCTION_NOT_AVAILABLE = 21
%VIS_INTERUPTED = 22

%ADD_OR_REPLACE = 0
%ADD_ONLY = 1
%REPLACE_ONLY = 2

%READ_ONLY = 0
'%READ_WRITE = 1
%READ_ONLY_SHARE = 2
%READ_WRITE_SHARE = 3


%XNOFINDER = 1
%XLOOKUP = 1
%XNEXT = 2
%XPREVIOUS = 4
%XCURRENT = 8

%XANY = 16
%XEQ = 32
%XBEGINS = 64
%XNOT = 128
%XLT = 256
%XGT = 512
%XLE = 1024
%XGE = 2048

%XGET_DATA = 4096
%XNO_DATA = 8192
%XNATIVE = 16384
%XFAST_READ = -32768

%NO_CACHE = -1
%SMALL_CACHE = 0
%LARGE_CACHE = 1

TYPE VBISAMInfo
    RecordsInFile           AS LONG
    GroupsUsed              AS INTEGER
    AllocatedGpsAvail       AS INTEGER
    MaxPrimaryKeyLen        AS INTEGER
    dummy1                  AS INTEGER
    GroupSize               AS LONG
    InitialAllocation       AS INTEGER
    IncrementalAllocation   AS INTEGER
    FreeFileNoteSpace       AS INTEGER
    dummy2                  AS INTEGER
    StandardFormat          AS STRING PTR
    Reserved                AS STRING PTR
END TYPE


'***************************************************************************

DECLARE FUNCTION VmxCreate LIB "vbis5032.DLL" ALIAS "VmxCreate"(DatasetName$, MaxKeyLength%, GroupSize&, InitialAllocation%, CreateOptions%, RecFormat$) AS INTEGER
DECLARE FUNCTION VmxKill LIB "vbis5032.DLL" ALIAS "VmxKill"(DatasetName$) AS INTEGER

DECLARE FUNCTION VmxOpen LIB "vbis5032.DLL" ALIAS "VmxOpen" (DatasetName$, LocatorLength%, AccessMode%, RHandle&, Password$) AS INTEGER
DECLARE FUNCTION VmxClose LIB "vbis5032.DLL" ALIAS "VmxClose" (DatasetHandle&) AS INTEGER

DECLARE FUNCTION VmxPut LIB "vbis5032.DLL" ALIAS "VmxPut" (DatasetHandle&, Key$, RecordVariable AS ANY, UpdateMode%) AS INTEGER
DECLARE FUNCTION VmxDelete LIB "vbis5032.DLL" ALIAS "VmxDelete" (DatasetHandle&, Key$) AS INTEGER

DECLARE FUNCTION VmxGet LIB "vbis5032.DLL" ALIAS "VmxGet"(DatasetHandle&, SecIndexField%, Options%, SelectorKey$, RSecondaryKey$, RPrimaryKey$, RRecordVariable AS ANY) AS INTEGER

DECLARE FUNCTION VmxBOF LIB "vbis5032.DLL" ALIAS "VmxBOF"(DatasetHandle&, SecIndexField%) AS INTEGER
DECLARE FUNCTION VmxEOF LIB "vbis5032.DLL" ALIAS "VmxEOF"(DatasetHandle&, SecIndexField%) AS INTEGER

DECLARE FUNCTION VmxWriteDict LIB "vbis5032.DLL" ALIAS "VmxWriteDict"(DatasetHandle&, DName$, DContents$) AS INTEGER
DECLARE FUNCTION VmxReadDict LIB "vbis5032.DLL" ALIAS "VmxReadDict"(DatasetHandle&, DName$, DContents$, XOption%) AS INTEGER
DECLARE FUNCTION VmxDeleteDict LIB "vbis5032.DLL" ALIAS "VmxDeleteDict"(DatasetHandle&, DName$) AS INTEGER
DECLARE FUNCTION VmxSetDictBof LIB "vbis5032.DLL" ALIAS "VmxSetDictBof"(DatasetHandle&) AS INTEGER

DECLARE FUNCTION VmxWriteNote LIB "vbis5032.DLL" ALIAS "VmxWriteNote"(DatasetHandle&, AttributeStringName$, AttributeStringContents$) AS INTEGER
DECLARE FUNCTION VmxReadNote LIB "vbis5032.DLL" ALIAS "VmxReadNote"(DatasetHandle&, Aname$, RAcontents$) AS INTEGER

DECLARE FUNCTION VmxFlush LIB "vbis5032.DLL" ALIAS "VmxFlush"(DatasetHandle&) AS INTEGER

DECLARE FUNCTION VmxInfo LIB "vbis5032.DLL" ALIAS "VmxInfo"(DatasetHandle&, VBISAMInfoStruct AS VBISAMInfo) AS INTEGER
DECLARE FUNCTION VmxReturnCode LIB "vbis5032.DLL" ALIAS "VmxReturnCode"(FunctionReturnCode%) AS STRING

DECLARE FUNCTION VmxEncode LIB "vbis5032.DLL" ALIAS "VmxEncode"(InStructure AS ANY, RecFormat$, ROutString$) AS INTEGER
DECLARE FUNCTION VmxDecode LIB "vbis5032.DLL" ALIAS "VmxDecode"(InString$, RecFormat$, ROutStructure AS ANY) AS INTEGER

' multiuser functions

DECLARE FUNCTION VmxLock LIB "vbis5032.DLL" ALIAS "VmxLock"(DatasetHandle&, Key$) AS INTEGER
DECLARE FUNCTION VmxUnlock LIB "vbis5032.DLL" ALIAS "VmxUnlock"(DatasetHandle&, Key$) AS INTEGER

DECLARE FUNCTION VmxHash LIB "vbis5032.DLL" ALIAS "VmxHash"(DatasetHandle&, Key$) AS LONG

' field functions

DECLARE FUNCTION VmxStoreField LIB "vbis5032.DLL" ALIAS "VmxStoreField" (DatasetHandle&, RecFormat$, Record$, FieldNo%, FieldType$, FldData AS ANY) AS INTEGER
DECLARE FUNCTION VmxFetchField LIB "vbis5032.DLL" ALIAS "VmxFetchField"(DatasetHandle&, RecFormat$, Record$, FieldNo%, FieldType$, RFldData AS ANY) AS INTEGER

' Move Current VB/ISAM Record Pointer

DECLARE FUNCTION VmxMovePtr LIB "vbis5032.DLL" ALIAS "VmxMovePtr"(DatasetHandle&, SecIndexField%, RelativeCount&, XOption%) AS INTEGER
DECLARE FUNCTION VmxCancel LIB "vbis5032.DLL" ALIAS "VmxCancel"(DatasetHandle&) AS INTEGER

' End vbis5032.BAS
'****************************************************************************

