'==============================================================================
'
'   vbIsamPB.bas
'   demo of VB/ISAM database manager
'
'   Provided Courtesy of Michael Meeks 2/8/2001.
'
'==============================================================================

#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
#INCLUDE "COMMCTRL.INC
#INCLUDE "V5032pb.inc"
'------------------------------------------------------------------------------
$AppTitle = "VB/ISAM Demo..."
'------------------------------------------------------------------------------

%ID_LISTBOX     = 1
%ID_BTNEXIT     = 2
%ID_STATUS      = 4
%ID_LABELFILE   = 3
%ID_TEXTFILE    = 5
%ID_OPT1        = 6
%ID_OPT2        = 7
%ID_OPT3        = 8
%ID_OPT4        = 9
%ID_LABELKEY    = 10
%ID_TEXTKEY     = 11

%ID_BTNCREATE   = 12
%ID_BTNOPEN     = 13
%ID_BTNCLOSE    = 14
%ID_BTNDELETE   = 15
%ID_BTNLOAD     = 16

%ID_BTNSTART    = 17
%ID_BTNSTOP     = 18
%ID_BTNREAD     = 19

'------------------------------------------------------------------------------

TYPE test_type
    f1(4)   AS INTEGER
    f6      AS STRING * 30
    f7(3)   AS STRING * 30
    f2      AS LONG
    f0      AS STRING * 3
    f3      AS SINGLE
    f4      AS DOUBLE
    f5      AS CUR
END TYPE

'------------------------------------------------------------------------------

GLOBAL g_hDlg       AS LONG
GLOBAL g_IsamHandle AS LONG
GLOBAL g_DoIt       AS LONG
GLOBAL MyRec        AS test_type
GLOBAL MyInfo       AS VBISAMInfo

'------------------------------------------------------------------------------

DECLARE FUNCTION AddLine( SendText AS ASCIIZ) AS LONG

'------------------------------------------------------------------------------
CALLBACK FUNCTION CreateButton

    LOCAL Txt           AS STRING
    LOCAL sfileName     AS STRING
    LOCAL sTestFormat   AS STRING
    LOCAL retCode       AS INTEGER
    LOCAL test_klen     AS INTEGER
    LOCAL lGroupSize    AS LONG

    CONTROL GET TEXT CBHNDL, %ID_TEXTFILE TO sfileName

    test_klen = 10
    lGroupSize = 32768
    sTestFormat = "A5%,$*30,A5$*30,&,$*3,!,#,@"
    retCode = VmxCreate(sfileName, test_klen, lGroupSize , 0, %XNOFINDER, sTestFormat)
    Txt = "Create " + VmxReturnCode$(retCode)
    CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)

    Txt = "0"
    CONTROL SET TEXT CBHNDL, %ID_TEXTKEY, Txt

END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION OpenButton

    LOCAL Txt       AS STRING
    LOCAL License   AS STRING
    LOCAL acc_mode  AS INTEGER
    LOCAL retCode   AS INTEGER
    LOCAL lngResult AS LONG
    LOCAL lngLoop   AS LONG

    '* * * License Key Goes Here * * *
    'License = ""

    g_IsamHandle = 0
    IF g_IsamHandle = 0 THEN

        acc_mode = -1
        FOR lngLoop = %ID_OPT1 TO %ID_OPT4
            CONTROL GET CHECK CBHNDL, lngLoop TO lngResult
            IF lngResult <> 0 THEN
                acc_mode = lngLoop - %ID_OPT1
                EXIT FOR
            END IF
        NEXT

        IF acc_mode < 0 THEN acc_mode = 3

        LOCAL sfileName AS STRING
        CONTROL GET TEXT CBHNDL, %ID_TEXTFILE TO sfileName
        retCode = VmxOpen(sfileName, %LARGE_CACHE, acc_mode, g_IsamHandle, License)
        Txt = "Open " & VmxReturnCode$(retCode)
        CONTROL SEND CBHNDL, %ID_LISTBOX, %LB_RESETCONTENT, 0, 0
        IF (retCode = %VIS_OK) THEN
            retCode = VmxInfo(g_IsamHandle, MyInfo)
            Txt = "Open " & VmxReturnCode$(retCode)
            LOCAL szMsg AS ASCIIZ * 100
            szMsg = "RecordsInFile -" & STR$(MyInfo.RecordsInFile)
            CALL AddLine ( szMsg )
            szMsg = "GroupsUsed -" & STR$(MyInfo.GroupsUsed)
            CALL AddLine ( szMsg )
            szMsg = "AllocatedGpsAvail -" & STR$(MyInfo.AllocatedGpsAvail)
            CALL AddLine ( szMsg )
            szMsg = "MaxPrimaryKeyLen -" & STR$(MyInfo.MaxPrimaryKeyLen)
            CALL AddLine ( szMsg )
            szMsg = "GroupSize -" & STR$(MyInfo.GroupSize)
            CALL AddLine ( szMsg )
            szMsg = "InitialAllocation -" & STR$(MyInfo.InitialAllocation)
            CALL AddLine ( szMsg )
            szMsg = "IncrementalAllocation -" & STR$(MyInfo.IncrementalAllocation)
            CALL AddLine ( szMsg )
            szMsg = "FreeFileNoteSpace -" & STR$(MyInfo.FreeFileNoteSpace)
            CALL AddLine ( szMsg )
            '******* CAN NOT return StandardFormat in PB**********
            'List1.AddItem MyInfo.StandardFormat
        END IF
    ELSE
        Txt = "File is already open."
    END IF

    CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)

END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION CloseButton

    LOCAL Txt       AS STRING
    LOCAL retCode   AS INTEGER

    IF g_IsamHandle <> 0 THEN
        retCode = VmxClose(g_IsamHandle)
        g_IsamHandle = 0
        Txt = "Close " + VmxReturnCode$(retCode)
    ELSE
        Txt = "File not open."
    END IF
    CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)

END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION DeleteButton

    LOCAL Txt       AS STRING
    LOCAL sfileName AS STRING
    LOCAL retCode   AS INTEGER

    Txt = ""
    retCode = MSGBOX("Do you really want to delete ?", 1, "DELETE")
    IF retCode = 1 THEN
        'Close file if it's open...
        IF g_IsamHandle <> 0 THEN
            retCode = VmxClose(g_IsamHandle)
            g_IsamHandle = 0
        END IF
        CONTROL GET TEXT CBHNDL, %ID_TEXTFILE TO sfileName
        retCode = VmxKill(sfileName)
        Txt = "Delete " + VmxReturnCode$(retCode)
    END IF
    CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)
END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION LoadButton()

    LOCAL Txt       AS STRING
    LOCAL sfileName AS STRING
    LOCAL retCode   AS INTEGER
    LOCAL t1        AS LONG
    LOCAL t2        AS LONG
    LOCAL xcount    AS LONG
    LOCAL lkey      AS STRING
    LOCAL hkey      AS STRING
    LOCAL lval      AS LONG
    LOCAL hval      AS LONG
    LOCAL mode      AS INTEGER
    LOCAL rps       AS CUR
    LOCAL secondary AS STRING
    LOCAL Primary   AS STRING
    LOCAL szMsg     AS ASCIIZ * 100

    IF g_IsamHandle <> 0 THEN

        g_DoIt = %True
        retCode = VmxBOF(g_IsamHandle, 0)
        CONTROL SEND CBHNDL, %ID_LISTBOX, %LB_RESETCONTENT, 0, 0
        mode = %XNEXT + %XGET_DATA

        t1 = TIMER

        xcount = 0
        DO WHILE g_DoIt = %True AND xcount <9000
            retCode = VmxGet(g_IsamHandle, 0, mode, hkey, secondary, Primary, MyRec)
            IF retCode = %VIS_NOT_FOUND THEN
                EXIT DO
            END IF
            IF retCode <> %VIS_OK THEN
                Txt = "Error " + VmxReturnCode$(retCode) + " " + hkey + " o=" + " n=" + lkey
                CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)
                EXIT DO
            END IF

            szMsg = Primary
            CALL AddLine ( szMsg )

            xcount = xcount + 1
            IF xcount MOD 1000 = 0 THEN
                t2 = TIMER
                rps = (xcount + 1) / (t2 - t1 + 1)
                Txt = STR$(xCount) + " Rec/Sec = " + STR$(rps)
                CONTROL SET TEXT CBHNDL, %ID_TEXTKEY, Txt

                DIALOG DOEVENTS
                IF xcount > 9000 THEN
                    EXIT DO
                END IF
            END IF
        LOOP
    END IF

END FUNCTION
'------------------------------------------------------------------------------
'------------------------------------------------------------------------------
CALLBACK FUNCTION StartButton

    LOCAL lval      AS LONG
    LOCAL hval      AS LONG
    LOCAL t1        AS LONG
    LOCAL t2        AS LONG
    LOCAL xCount    AS LONG
    LOCAL maxCnt    AS LONG
    LOCAL rps       AS CUR
    LOCAL retCode   AS INTEGER
    LOCAL lkey      AS STRING
    LOCAL hkey      AS STRING
    LOCAL Txt       AS STRING

    IF g_IsamHandle <> 0 THEN
        MyRec.f0 = "AAA"
        MyRec.f1(0) = 0
        MyRec.f1(1) = 1
        MyRec.f1(2) = 2
        MyRec.f1(3) = 3
        MyRec.f1(4) = 4
        MyRec.f2 = 0
        MyRec.f3 = 7777777777#
        MyRec.f4 = 8888888888#
        MyRec.f5 = 1.95
        MyRec.f6 = "FIXED LENGTH of 30"
        MyRec.f7(0) = "Array 0 FIXED LENGTH of 30"
        MyRec.f7(1) = "Array 1 FIXED LENGTH of 30"
        MyRec.f7(2) = "Array 2 FIXED LENGTH of 30"
        MyRec.f7(3) = "Array 3 FIXED LENGTH of 30"


        g_DoIt = %True
        t1 = TIMER

        xcount = 0
        DO WHILE ISTRUE g_DoIt

            MyRec.f2 = MyRec.f2 + 1
            lkey = LTRIM$(STR$(lval))
            'hval = VmxHash(g_IsamHandle, lkey)
            hkey = RIGHT$("0000000000" + HEX$(lval), 10)
            retCode = VmxPut(g_IsamHandle, hkey, MyRec, %ADD_ONLY)
            IF retCode <> %VIS_OK THEN
                IF retCode = %VIS_UPDATE_VIOLATION THEN
                   ' Collision is OK!
                ELSE
                    Txt = "Error " + VmxReturnCode$(retCode) + " " + hkey + " o=" + " n=" + lkey
                    CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)
                    EXIT DO
                END IF
            END IF
            lval = lval + 1
            xcount = xcount + 1
            IF lval MOD 500 = 0 THEN
                t2 = TIMER
                rps = (xcount + 1) / (t2 - t1 + 1)
                Txt = STR$(lval) + " Rec/Sec = " + STR$(rps) ', "#.000")
                CONTROL SET TEXT CBHNDL, %ID_TEXTKEY, Txt
                DIALOG DOEVENTS
            END IF
            INCR maxCnt

        LOOP

        'Txt = STR$(lval)
        'CONTROL SET TEXT CBHNDL, %ID_TEXTKEY, Txt
    END IF

END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION StopButton
    g_DoIt = %False
END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION ReadButton

    LOCAL lval      AS LONG
    LOCAL hval      AS LONG
    LOCAL retCode   AS INTEGER
    LOCAL lkey      AS STRING
    LOCAL hkey      AS STRING
    LOCAL dummy1    AS STRING
    LOCAL dummy2    AS STRING
    LOCAL Txt       AS STRING

    IF g_IsamHandle <> 0 THEN

        CONTROL GET TEXT CBHNDL, %ID_TEXTKEY TO Txt
        lval = VAL(Txt)
        lkey = LTRIM$(STR$(lval))

        'hval = VmxHash(g_IsamHandle, lkey)
        hkey = RIGHT$("0000000000" + HEX$(lval), 10)
        lval = lval + 1
        Txt = STR$(lval)
        CONTROL SET TEXT CBHNDL, %ID_TEXTKEY, Txt

        CONTROL SEND CBHNDL, %ID_LISTBOX, %LB_RESETCONTENT, 0, 0

        retCode = VmxGet(g_IsamHandle, 0, %XLOOKUP + %XGET_DATA, hkey, dummy1, dummy2, MyRec)
        IF retCode = %VIS_OK THEN
            LOCAL szMsg AS ASCIIZ * 120

            szMsg = hkey
            CALL AddLine ( szMsg )

            szMsg = MyRec.f0
            CALL AddLine ( szMsg )

            szMsg = STR$(MyRec.f1(0)) + "," + STR$(MyRec.f1(1)) + "," + STR$(MyRec.f1(2)) + "," + STR$(MyRec.f1(3))
            CALL AddLine ( szMsg )

            szMsg = STR$(MyRec.f2)
            CALL AddLine ( szMsg )

            szMsg = STR$(MyRec.f3)
            CALL AddLine ( szMsg )

            szMsg = STR$(MyRec.f4)
            CALL AddLine ( szMsg )

            szMsg = STR$(MyRec.f5)
            CALL AddLine ( szMsg )

            szMsg = MyRec.f6
            CALL AddLine ( szMsg )

            szMsg = MyRec.f7(0)
            CALL AddLine ( szMsg )

            szMsg = MyRec.f7(1)
            CALL AddLine ( szMsg )

            szMsg = MyRec.f7(2)
            CALL AddLine ( szMsg )

            szMsg = MyRec.f7(3)
            CALL AddLine ( szMsg )

        ELSE
            MSGBOX "Error " + VmxReturnCode$(retCode) + " get " + lkey
        END IF
    END IF

END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION optButton_CB()

    LOCAL Txt AS STRING

    Txt = "Option button" &  STR$(CBCTL) & " Pressed"
    CONTROL SEND CBHNDL, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)
END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION ExitButton()

    DIALOG END CBHNDL

END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION MainDlg_CallBack()

    STATIC hBrushBlack AS LONG

    SELECT CASE CBMSG
    CASE %WM_INITDIALOG
        LOCAL Lb AS LOGBRUSH
        Lb.lbStyle  = %BLACK_BRUSH
        'Lb.lbColor  = %Black
        Lb.lbColor  = %Red
        hBrushBlack = CreateBrushIndirect(Lb)
    CASE %WM_CTLCOLORDLG
        ' paint the background of the Dailog
        FUNCTION = hBrushBlack
        EXIT FUNCTION
    CASE %WM_SIZE
        'IMPORTANT
        're-size Status Bar
        CONTROL SEND CBHNDL, %ID_STATUS, CBMSG , CBWPARAM , CBLPARAM
    CASE %WM_DESTROY
        DeleteObject hBrushBlack
        IF g_IsamHandle <> 0 THEN
            LOCAL intReturn AS INTEGER
            intReturn = VmxClose(g_IsamHandle)
            IF intReturn <> %VIS_OK THEN
                MSGBOX "Error Closing File " & VmxReturnCode$(intReturn)
            END IF
        END IF

    END SELECT
END FUNCTION
'------------------------------------------------------------------------------

FUNCTION PBMAIN () AS LONG

    #REGISTER NONE

    DIM sbParts(0) AS LONG
    LOCAL hDlg   AS LONG
    LOCAL result AS LONG

    InitCommonControls

    ' ** Create a new dialog template
    DIALOG NEW 0, $AppTitle,,, 400, 190, _
                  %WS_SYSMENU OR %WS_CAPTION OR _
                  %WS_THICKFRAME OR %WS_OVERLAPPEDWINDOW OR _
                  %WS_VISIBLE , 0 TO hDlg

    g_hDlg = hDlg

    ' ** Add controls to it

    CONTROL ADD "msctls_statusbar32", hDlg, %ID_STATUS,"" ,0 , 0 , 0, 16, _
                      %WS_CHILD OR _
                      %WS_BORDER OR _
                      %WS_VISIBLE OR _
                      %SBS_SIZEGRIP

    sbParts(0) = -1
    CONTROL SEND hDlg, %ID_STATUS, %SB_SETPARTS,1, VARPTR(sbParts(0))

    LOCAL Txt AS STRING

    CONTROL ADD LABEL , hDlg, %ID_LABELFILE, " FileName" , 10, 10, 50, 12', %SS_SUNKEN
    Txt = "c:\testpb"
    CONTROL ADD TEXTBOX, hDlg, %ID_TEXTFILE, txt, 60, 10, 100, 12, %WS_TABSTOP, %WS_EX_WINDOWEDGE    'CALL callbackfunction

    CONTROL ADD OPTION, hDlg, %ID_OPT1, "0 - Read Only"        , 10, 40, 86, 12, %WS_TABSTOP, 0 CALL optButton_CB
    CONTROL ADD OPTION, hDlg, %ID_OPT2, "1 - Read Write"       , 10, 60, 86, 12, %WS_TABSTOP, 0 CALL optButton_CB
    CONTROL ADD OPTION, hDlg, %ID_OPT3, "2 - Read Only Shared" , 10, 80, 86, 12, %WS_TABSTOP, 0 CALL optButton_CB
    CONTROL ADD OPTION, hDlg, %ID_OPT4, "3 - Read Write Shared", 10,100, 86, 12, %WS_TABSTOP, 0 CALL optButton_CB

    CONTROL SET CHECK hDlg, %ID_OPT2, %TRUE

    CONTROL ADD LABEL , hDlg, %ID_LABELKEY, " Starting Key" , 10, 120, 50, 12

    Txt = "0"
    CONTROL ADD TEXTBOX, hDlg, %ID_TEXTKEY, txt, 60, 120, 100, 12, %WS_TABSTOP OR %ES_NUMBER  , %WS_EX_WINDOWEDGE    'CALL callbackfunction


    CONTROL ADD BUTTON, hDlg, %ID_BTNCREATE, "Create", 200,  40, 50, 14, %WS_TABSTOP, 0 CALL CreateButton
    CONTROL ADD BUTTON, hDlg, %ID_BTNOPEN  , "Open"  , 200,  60, 50, 14, %WS_TABSTOP, 0 CALL OpenButton
    CONTROL ADD BUTTON, hDlg, %ID_BTNCLOSE , "Close" , 200,  80, 50, 14, %WS_TABSTOP, 0 CALL CloseButton
    CONTROL ADD BUTTON, hDlg, %ID_BTNDELETE, "Delete", 200, 100, 50, 14, %WS_TABSTOP, 0 CALL DeleteButton
    CONTROL ADD BUTTON, hDlg, %ID_BTNLOAD  , "Load"  , 200, 120, 50, 14, %WS_TABSTOP, 0 CALL LoadButton


    CONTROL ADD BUTTON, hDlg, %ID_BTNSTART   , "Start"   ,  20, 140, 50, 14, %WS_TABSTOP, 0 CALL StartButton
    CONTROL ADD BUTTON, hDlg, %ID_BTNSTOP    , "Stop"    ,  80, 140, 50, 14, %WS_TABSTOP, 0 CALL StopButton
    CONTROL ADD BUTTON, hDlg, %ID_BTNREAD    , "Read"    , 140, 140, 50, 14, %WS_TABSTOP, 0 CALL ReadButton


    DIM TxtArray(1) AS STRING
    TxtArray(1) = "This listbox shows the Messages..."

    CONTROL ADD LISTBOX,  hDlg, %ID_LISTBOX, TxtArray(), 265, 10, 130, 126, _
                        %WS_BORDER OR _
                        %LBS_DISABLENOSCROLL OR %WS_VSCROLL OR _
                        %WS_GROUP OR %WS_TABSTOP OR _
                        %LBS_NOINTEGRALHEIGHT


    CONTROL ADD BUTTON, hDlg, %ID_BTNEXIT, "Exit", 325, 155, 50, 14, 0 CALL ExitButton
    Txt = "Status...."
    CONTROL SEND hDlg, %ID_STATUS, %SB_SETTEXT,0, STRPTR(Txt)

    ' ** Display the dialog
    DIALOG SHOW MODAL hDlg, CALL MainDlg_CallBack TO result

END FUNCTION


'------------------------------------------------------------------------------
FUNCTION AddLine( SendText AS ASCIIZ) AS LONG

    ' update the listbox
    CONTROL SEND g_hDlg, %ID_LISTBOX, %LB_ADDSTRING, 0, VARPTR(SendText)

END FUNCTION










                                                                                                                                                                                                                                 