//****************************************************************************
//
// (c) COPYRIGHT SOFTWARE SOURCE  1991 - 2003
//     ALL RIGHTS RESERVED
//
// program - vbis5032.h
// purpose - VMX Library definitions.
// author  - Tony Altwies
// history - 1-18-96
//
//  REMEMBER: For VmxGet and VmxPut, the Data is found in the place pointed to
//            by "lpTypeDef". You must allocate this space or get it from VB.
//            It must correspond to a VB structure form, which has a 4-byte
//            Structure Member Alignment. See "PAS_&_C.TXT".
//
//****************************************************************************

# define VIS_OK                       0
# define VIS_NOT_FOUND                1
# define VIS_UPDATE_VIOLATION         2
# define VIS_ACCESS_DENIED            3
# define VIS_BAD_DATASET_NUMBER       4
# define VIS_BAD_FORMAT               5
# define VIS_INVALID_KEY              6
# define VIS_BAD_PARAMETER_VALUE      7
# define VIS_BAD_FILE                 8
# define VIS_ALREADY_EXISTS           9
# define VIS_NO_ROOM                  10
# define VIS_DISK_FULL                11
# define VIS_OUT_OF_MEMORY            12
# define VIS_DOS_ERROR                13
# define VIS_DISK_ERROR               14
# define VIS_DATA_VALIDITY_CHECK      15
# define VIS_INVALID_SECONDARY_KEY    16
# define VIS_SEQUENCE_ERROR           17
# define VIS_OUT_OF_FILE_HANDLES      18
# define VIS_BUSY                     19
# define VIS_INVALID_PASSWORD         20
# define VIS_FUNCTION_NOT_AVAILABLE   21
# define VIS_INTERUPTED               22
# define VIS_BAD_PASSWORD             23


# define XLOOKUP                      1
# define XNEXT                        2
# define XPREVIOUS                    4
# define XCURRENT                     8

# define XANY                         16
# define XEQ                          32
# define XBEGINS                      64

# define XNOT                         128
# define XLT                          256
# define XGT                          512
# define XLE                          1024
# define XGE                          2048

# define READ_ONLY                    0
# define READ_ONLY_EXCLUSIVE          0
# define READ_WRITE                   1
# define READ_WRITE_EXCLUSIVE         1
# define READ_ONLY_SHARE              2
# define READ_ONLY_SHARED             2
# define READ_WRITE_SHARE             3
# define READ_WRITE_SHARED            3


// flags for VmxGet

# define XGET_DATA                    4096
# define XNO_DATA                     8192
# define XNATIVE                      16384

// flags for VmxPut

# define XADD_ONLY                    1
# define XREPLACE_ONLY                2
# define XADD_OR_REPLACE              4


# ifndef RC_INVOKED
#pragma pack(4)
# endif // RC_INVOKED

typedef struct tagVSTATS
  {
    LONG   nrecords;
    WORD   gps_used;
    WORD   gps_unused;
    WORD   max_key_len;
    LONG   grp_size;
    WORD   init_alloc;
    WORD   cr_opts;
    WORD   free_prop_area;
    BSTR   format;
    BSTR   reserved;

  } VSTATS;

typedef VSTATS FAR * LPVSTATS;

# ifndef RC_INVOKED
#pragma pack()
# endif // RC_INVOKED
#define LPSHORT short *

// function prototypes

short FAR PASCAL VmxCreate(BSTR   *Filespec,
                           LPSHORT lpMaxKeyWidth,
                           LPLONG  lpGroupSize,
                           LPSHORT lpInitAlloc,
                           LPSHORT lpCrOpts,
                           BSTR   *Format);

short FAR PASCAL VmxCreateEx(BSTR   *Filespec,
                           LPSHORT lpMaxKeyWidth,
                           LPLONG  lpGroupSize,
                           LPSHORT lpInitAlloc,
                           LPSHORT lpCrOpts,
                           BSTR   *Format,
                           BSTR   *EKey);

short FAR PASCAL VmxKill(BSTR *Filespec);

short FAR PASCAL VmxOpen(BSTR    *Filespec,
                         LPSHORT  lpLocatorSize,
                         LPSHORT  lpOmode,
                         LPHANDLE lphwmcb,
                         BSTR    *Password);

short FAR PASCAL VmxOpenEx(BSTR    *Filespec,
                         LPSHORT  lpLocatorSize,
                         LPSHORT  lpOmode,
                         LPHANDLE lphwmcb,
                         BSTR    *Password,
                         BSTR    *Ekey);

short FAR PASCAL VmxClose(LPHANDLE lpDatasetNumber);

short FAR PASCAL VmxGet(LPHANDLE lpDatasetNumber, LPSHORT lpSecIndex,
                        LPSHORT lpOption, BSTR *SrchKey,
                        BSTR  *SecKey, BSTR  *PriKey, LPSTR lpTypeDef);

short FAR PASCAL VmxPut(LPHANDLE lpDatasetNumber, BSTR  *Key,
                        LPSTR lpTypeDef, LPSHORT lpprotmode);

short FAR PASCAL VmxDelete(LPHANDLE lpDatasetNumber, BSTR  *Key);

short FAR PASCAL VmxBOF(LPHANDLE lpDatasetNumber, LPSHORT lpSecIndex);
short FAR PASCAL VmxEOF(LPHANDLE lpDatasetNumber, LPSHORT lpSecIndex);

short FAR PASCAL VmxMovePtr(LPHANDLE lpDatasetNumber, LPSHORT lpSecIndex,
                            LPLONG lpRelativeCount, LPSHORT lpOption );

short FAR PASCAL VmxCancel(LPHANDLE lpDatasetNumber);

short FAR PASCAL VmxWriteNote(LPHANDLE lpDatasetNumber, BSTR  *Pname,
                              BSTR  *Pstring);

short FAR PASCAL VmxReadNote(LPHANDLE lpDatasetNumber, BSTR  *Pname,
                             BSTR  *Pstring);

short FAR PASCAL VmxFlush(LPHANDLE lpDatasetNumber);
short FAR PASCAL VmxInfo(LPHANDLE lpDatasetNumber, LPVSTATS lpvstats);
BSTR  FAR PASCAL VmxReturnCode(LPSHORT lperrno);

short FAR PASCAL VmxEncode(LPSTR lpTypeDef, BSTR  *Dict, BSTR  *Record);
short FAR PASCAL VmxDecode(BSTR  *Record, BSTR  *Dict, LPSTR lpTypeDef);

short FAR PASCAL VmxLock(LPHANDLE lpDatasetNumber, BSTR  *Key);
short FAR PASCAL VmxUnlock(LPHANDLE lpDatasetNumber, BSTR  *Key);

short FAR PASCAL VmxFetchField(
                           LPHANDLE lpDatasetNumber,
                           BSTR         *Dict,
                           BSTR         *Record,
                           LPSHORT       lpFldNo,
                           BSTR         *FldType,
                           LPSTR         lpFieldData);

short FAR PASCAL VmxStoreField(
                           LPHANDLE lpDatasetNumber,
                           BSTR         *Dict,
                           BSTR         *Record,
                           LPSHORT       lpFldNo,
                           BSTR         *FldType,
                           LPSTR         lpFieldData);

short FAR PASCAL VmxReadDict(LPHANDLE lpDatasetNumber,
                             BSTR       *DictKey,
                             BSTR       *DictData,
                             LPSHORT     lpOpt);

short FAR PASCAL VmxSetDictBof(LPHANDLE lpDatasetNumber);
short FAR PASCAL VmxSetDictEof(LPHANDLE lpDatasetNumber);

short FAR PASCAL VmxWriteDict(LPHANDLE lpDatasetNumber,
                             BSTR       *DictKey,
                             BSTR       *DictData);

short FAR PASCAL VmxDeleteDict(LPHANDLE lpDatasetNumber,
                             BSTR       *DictKey);

//****************************************************************************
