
// caddg.h

# ifdef CADD_MAIN
#   define EXTERN
# else
#   define EXTERN extern
# endif // CADD_MAIN


// record definition

# ifndef RC_INVOKED
#pragma pack(4)
# endif // RC_INVOKED


typedef struct tagMYREC
  {
    char    name[51];        //  1 xref generated name key

    char    lastname[31];    //  2      last name
    char    firstname[21];   //  3      first name
    char    address[41];     //  4      address
    char    city[31];        //  5 xref city key
    char    state[3];        //  6 xref state
    char    zip[11];         //  7 xref zip code
    char    phone[21];       //  8 xref phone number
    BSTR    notes;           //  9      notes

  } MYREC;
typedef MYREC FAR * LPMYREC;

# ifndef RC_INVOKED
#pragma pack()
# endif // RC_INVOKED


// standard format string for record

EXTERN char myrec_fmt[] = "X$*51,$*31,$*21,$*41,X$*31,X$*3,X$*11,X$*21,$";

// key length for record

EXTERN short  myrec_keylen = 10;

EXTERN HANDLE    hInst;            // hInstance of application


// function prototypes

//int      PASCAL        WinMain(HANDLE hInstance,
//                               HANDLE hPrevInstance,
//                               LPSTR  lpszCmdLine,
//                               int    cmdShow);

BOOL CALLBACK AddressDlg(
    HWND              hDlg,
    UINT              message,
    WPARAM            wParam,
    LPARAM            lParam);

void                   show_record(HWND    hDlg,
                                   HANDLE  nDatasetNumber,
                                   LPSTR   lpkey,
                                   LPMYREC lpmyrec);

int                    build_record(HWND    hDlg,
                                    LPSTR   buf,
                                    WORD    lbuf,
                                    LPMYREC lpmyrec);

void                   clear_display(HWND hDlg);

int                    get_cur_index(HWND hDlg);

void                   save_wnd_pos(HWND  hWnd,
                                    LPSTR szIniFileName,
                                    LPSTR szIniSectionName,
                                    LPSTR szIniParmName);

void                   set_wnd_pos(HWND  hWnd,
                                   LPSTR szIniFileName,
                                   LPSTR szIniSectionName,
                                   LPSTR szIniParmName);

# undef EXTERN

// end caddg.h

